/*
 *   NOTE: this is a machine generated file - editing not recommended
 * ----------------------------------------------------------------------------
 *  (C) Copyright Testing Technologies, 2000-2007.  All Rights Reserved.
 *
 *  All copies of this program, whether in whole or in part, and whether
 *  modified or not, must display this and all other embedded copyright
 *  and ownership notices in full.
 *
 *  See the file COPYRIGHT and LICENSE for details of redistribution
 *  and use.
 *
 *  You should have received a copy of the COPYRIGHT and LICENSE file
 *  along with this file; if not, write to the Testing Technologies,
 *  Rosenthaler Str. 13, 10119 Berlin, Germany.
 *
 * ----------------------------------------------------------------------------
 *
 *   Source File: D:\\dte\\workspaces\\workspace_ipv6\\IPv6_ETSI_STF276_P2_new\\ttcn3\\EtsiLibrary\\LibIpv6\\LibCommonRfcs\\LibIpv6_Interface_TypesAndValues.ttcn
 *   File       : TabularLibIpv6_Interface_TypesAndValues.java
 *
 *   This is a Java class providing a com.testingtech.ttcn.tci based decoding
 *   using tabular encoding information within a TTCN-3 file.
 *
 *   This file was generated by TabularCodecGenerator(version v1.0)
  *  at 21.05.2007 21:39:57
 *
 *   REVISION INFO:
 *        $Revision: 1.4 $ $Date: 2007/02/26 10:03:23 $
 * -----------------------------------------------------------------------------
 */
package com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues;

import com.testingtech.ttcn.logging.RTLoggingConstants;
import com.testingtech.ttcn.tci.ExtendedTciTypeClass;
import com.testingtech.ttcn.tci.codec.base.AbstractBaseCodec;
import com.testingtech.ttcn.tci.codec.tabular.TabularDecoder;
import com.testingtech.ttcn.tci.codec.tabular.TabularEncoder;
import com.testingtech.ttcn.tci.codec.tabular.TabularException;
import com.testingtech.ttcn.tri.TriMessageImpl;

import com.testingtech.util.BitArrayInputStream;
import com.testingtech.util.BitArrayOutputStream;

import de.tu_berlin.cs.uebb.muttcn.runtime.RB;
import de.tu_berlin.cs.uebb.muttcn.runtime.ValueImpl;

import org.etsi.ttcn.tci.Type;
import org.etsi.ttcn.tci.Value;
import org.etsi.ttcn.tri.TriMessage;


public class TabularLibIpv6_Interface_TypesAndValues extends AbstractBaseCodec {
    private BitArrayInputStream bis = null;

    public TabularLibIpv6_Interface_TypesAndValues(RB rb) {
        super(rb);
    }

    public Value decode(TriMessage rm, Type dh) {
        logDecode("TabularLibIpv6_Interface_TypesAndValues: entering decode");

        if (rm == null) {
            RB.getTciTLProvided().tliRT("", System.currentTimeMillis(), null,
                -1, null, RTLoggingConstants.RT_LOG_ERROR,
                "TabularLibIpv6_Interface_TypesAndValues: Aborting decoding due to received TriMessage is null!");

            return null;
        }

        if (dh == null) {
            RB.getTciTLProvided().tliRT("", System.currentTimeMillis(), null,
                -1, null, RTLoggingConstants.RT_LOG_ERROR,
                "TabularLibIpv6_Interface_TypesAndValues: Aborting decoding due to decoding hypothesis is null!");

            return null;
        }

        Value v = null;
        byte[] em = rm.getEncodedMessage();
        bis = new BitArrayInputStream(em);

        TabularDecoder td = new TabularDecoder(bis, RB);

        String typeName = dh.getName();
        logDecode("TabularLibIpv6_Interface_TypesAndValues: typeName is " +
            typeName);

        if (dh.getTypeClass() == ExtendedTciTypeClass.ANY) {
            logDecode(
                "TabularLibIpv6_Interface_TypesAndValues: decode(TriMessage, Type): decodingHypothesis is of typeClass ANY");

            Value theValue = dh.newInstance();

            ((ValueImpl) theValue).setPresent();
            logDecode(
                "TabularLibIpv6_Interface_TypesAndValues: decode(TriMessage, Type): decodingHypothesis is of typeClass ANY: theValue.getClass().getName(): " +
                theValue.getClass().getName());

            return theValue;
        }

        try {
            // generated because of "isPDU"
            if (typeName.equals("Ipv6Packet")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularIpv6Packet d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularIpv6Packet(dh.newInstance());
                d.decode(td);
                v = d.toValue();

                if ((v == null) || v.notPresent()) {
                    return null;
                }

                return v;
            } else
            // generated because of "isPDU"
            if (typeName.equals("DestinationUnreachable")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularDestinationUnreachable d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularDestinationUnreachable(dh.newInstance());
                d.decode(td);
                v = d.toValue();

                if ((v == null) || v.notPresent()) {
                    return null;
                }

                return v;
            } else
            // generated because of "isPDU"
            if (typeName.equals("PacketTooBig")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularPacketTooBig d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularPacketTooBig(dh.newInstance());
                d.decode(td);
                v = d.toValue();

                if ((v == null) || v.notPresent()) {
                    return null;
                }

                return v;
            } else
            // generated because of "isPDU"
            if (typeName.equals("TimeExceeded")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularTimeExceeded d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularTimeExceeded(dh.newInstance());
                d.decode(td);
                v = d.toValue();

                if ((v == null) || v.notPresent()) {
                    return null;
                }

                return v;
            } else
            // generated because of "isPDU"
            if (typeName.equals("ParameterProblem")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularParameterProblem d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularParameterProblem(dh.newInstance());
                d.decode(td);
                v = d.toValue();

                if ((v == null) || v.notPresent()) {
                    return null;
                }

                return v;
            } else
            // generated because of "isPDU"
            if (typeName.equals("EchoRequest")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularEchoRequest d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularEchoRequest(dh.newInstance());
                d.decode(td);
                v = d.toValue();

                if ((v == null) || v.notPresent()) {
                    return null;
                }

                return v;
            } else
            // generated because of "isPDU"
            if (typeName.equals("EchoReply")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularEchoReply d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularEchoReply(dh.newInstance());
                d.decode(td);
                v = d.toValue();

                if ((v == null) || v.notPresent()) {
                    return null;
                }

                return v;
            } else
            // generated because of "isPDU"
            if (typeName.equals("RouterAdvertisement")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularRouterAdvertisement d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularRouterAdvertisement(dh.newInstance());
                d.decode(td);
                v = d.toValue();

                if ((v == null) || v.notPresent()) {
                    return null;
                }

                return v;
            } else
            // generated because of "isPDU"
            if (typeName.equals("RouterSolicitation")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularRouterSolicitation d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularRouterSolicitation(dh.newInstance());
                d.decode(td);
                v = d.toValue();

                if ((v == null) || v.notPresent()) {
                    return null;
                }

                return v;
            } else
            // generated because of "isPDU"
            if (typeName.equals("NeighborSolicitation")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularNeighborSolicitation d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularNeighborSolicitation(dh.newInstance());
                d.decode(td);
                v = d.toValue();

                if ((v == null) || v.notPresent()) {
                    return null;
                }

                return v;
            } else
            // generated because of "isPDU"
            if (typeName.equals("NeighborAdvertisement")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularNeighborAdvertisement d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularNeighborAdvertisement(dh.newInstance());
                d.decode(td);
                v = d.toValue();

                if ((v == null) || v.notPresent()) {
                    return null;
                }

                return v;
            } else
            // generated because of "isPDU"
            if (typeName.equals("Redirect")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularRedirect d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularRedirect(dh.newInstance());
                d.decode(td);
                v = d.toValue();

                if ((v == null) || v.notPresent()) {
                    return null;
                }

                return v;
            } else
            // generated because of "isPDU"
            if (typeName.equals("RouterRenumbering")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularRouterRenumbering d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularRouterRenumbering(dh.newInstance());
                d.decode(td);
                v = d.toValue();

                if ((v == null) || v.notPresent()) {
                    return null;
                }

                return v;
            } else
            // generated because of "isPDU"
            if (typeName.equals("HomeAgentAddressDiscoveryRequest")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularHomeAgentAddressDiscoveryRequest d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularHomeAgentAddressDiscoveryRequest(dh.newInstance());
                d.decode(td);
                v = d.toValue();

                if ((v == null) || v.notPresent()) {
                    return null;
                }

                return v;
            } else
            // generated because of "isPDU"
            if (typeName.equals("HomeAgentAddressDiscoveryReply")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularHomeAgentAddressDiscoveryReply d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularHomeAgentAddressDiscoveryReply(dh.newInstance());
                d.decode(td);
                v = d.toValue();

                if ((v == null) || v.notPresent()) {
                    return null;
                }

                return v;
            } else
            // generated because of "isPDU"
            if (typeName.equals("MobilePrefixSolicitation")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularMobilePrefixSolicitation d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularMobilePrefixSolicitation(dh.newInstance());
                d.decode(td);
                v = d.toValue();

                if ((v == null) || v.notPresent()) {
                    return null;
                }

                return v;
            } else
            // generated because of "isPDU"
            if (typeName.equals("MobilePrefixAdvertisement")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularMobilePrefixAdvertisement d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularMobilePrefixAdvertisement(dh.newInstance());
                d.decode(td);
                v = d.toValue();

                if ((v == null) || v.notPresent()) {
                    return null;
                }

                return v;
            } else
            // generated because of "isPDU"
            if (typeName.equals("MipRouterAdvertisement")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularMipRouterAdvertisement d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularMipRouterAdvertisement(dh.newInstance());
                d.decode(td);
                v = d.toValue();

                if ((v == null) || v.notPresent()) {
                    return null;
                }

                return v;
            } else
            // generated because of "isPDU"
            if (typeName.equals("BindingRefreshRequest")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularBindingRefreshRequest d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularBindingRefreshRequest(dh.newInstance());
                d.decode(td);
                v = d.toValue();

                if ((v == null) || v.notPresent()) {
                    return null;
                }

                return v;
            } else
            // generated because of "isPDU"
            if (typeName.equals("HomeTestInit")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularHomeTestInit d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularHomeTestInit(dh.newInstance());
                d.decode(td);
                v = d.toValue();

                if ((v == null) || v.notPresent()) {
                    return null;
                }

                return v;
            } else
            // generated because of "isPDU"
            if (typeName.equals("CareOfTestInit")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularCareOfTestInit d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularCareOfTestInit(dh.newInstance());
                d.decode(td);
                v = d.toValue();

                if ((v == null) || v.notPresent()) {
                    return null;
                }

                return v;
            } else
            // generated because of "isPDU"
            if (typeName.equals("HomeTest")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularHomeTest d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularHomeTest(dh.newInstance());
                d.decode(td);
                v = d.toValue();

                if ((v == null) || v.notPresent()) {
                    return null;
                }

                return v;
            } else
            // generated because of "isPDU"
            if (typeName.equals("CareOfTest")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularCareOfTest d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularCareOfTest(dh.newInstance());
                d.decode(td);
                v = d.toValue();

                if ((v == null) || v.notPresent()) {
                    return null;
                }

                return v;
            } else
            // generated because of "isPDU"
            if (typeName.equals("BindingUpdate")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularBindingUpdate d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularBindingUpdate(dh.newInstance());
                d.decode(td);
                v = d.toValue();

                if ((v == null) || v.notPresent()) {
                    return null;
                }

                return v;
            } else
            // generated because of "isPDU"
            if (typeName.equals("BindingAcknowledgement")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularBindingAcknowledgement d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularBindingAcknowledgement(dh.newInstance());
                d.decode(td);
                v = d.toValue();

                if ((v == null) || v.notPresent()) {
                    return null;
                }

                return v;
            } else
            // generated because of "isPDU"
            if (typeName.equals("BindingError")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularBindingError d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularBindingError(dh.newInstance());
                d.decode(td);
                v = d.toValue();

                if ((v == null) || v.notPresent()) {
                    return null;
                }

                return v;
            } else
            // generated because of "isPDU"
            if (typeName.equals("FastBindingUpdate")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularFastBindingUpdate d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularFastBindingUpdate(dh.newInstance());
                d.decode(td);
                v = d.toValue();

                if ((v == null) || v.notPresent()) {
                    return null;
                }

                return v;
            } else
            // generated because of "isPDU"
            if (typeName.equals("FastBindingAcknowledgement")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularFastBindingAcknowledgement d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularFastBindingAcknowledgement(dh.newInstance());
                d.decode(td);
                v = d.toValue();

                if ((v == null) || v.notPresent()) {
                    return null;
                }

                return v;
            } else
            // generated because of "isPDU"
            if (typeName.equals("FastNeighborAdvertisement")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularFastNeighborAdvertisement d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularFastNeighborAdvertisement(dh.newInstance());
                d.decode(td);
                v = d.toValue();

                if ((v == null) || v.notPresent()) {
                    return null;
                }

                return v;
            } else
            // generated because of "isPDU"
            if (typeName.equals("RouterSolicitationForProxyRtAdv")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularRouterSolicitationForProxyRtAdv d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularRouterSolicitationForProxyRtAdv(dh.newInstance());
                d.decode(td);
                v = d.toValue();

                if ((v == null) || v.notPresent()) {
                    return null;
                }

                return v;
            } else
            // generated because of "isPDU"
            if (typeName.equals("ProxyRouterAdvertisement")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularProxyRouterAdvertisement d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularProxyRouterAdvertisement(dh.newInstance());
                d.decode(td);
                v = d.toValue();

                if ((v == null) || v.notPresent()) {
                    return null;
                }

                return v;
            } else
            // generated because of "isPDU"
            if (typeName.equals("HandoverInitiate")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularHandoverInitiate d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularHandoverInitiate(dh.newInstance());
                d.decode(td);
                v = d.toValue();

                if ((v == null) || v.notPresent()) {
                    return null;
                }

                return v;
            } else
            // generated because of "isPDU"
            if (typeName.equals("HandoverAcknowledge")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularHandoverAcknowledge d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularHandoverAcknowledge(dh.newInstance());
                d.decode(td);
                v = d.toValue();

                if ((v == null) || v.notPresent()) {
                    return null;
                }

                return v;
            } else
            // generated because of "isPDU"
            if (typeName.equals("OtherIcmpv6")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularOtherIcmpv6 d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularOtherIcmpv6(dh.newInstance());
                d.decode(td);
                v = d.toValue();

                if ((v == null) || v.notPresent()) {
                    return null;
                }

                return v;
            } else
            // generated because of "isPDU"
            if (typeName.equals("UdpPacket")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularUdpPacket d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularUdpPacket(dh.newInstance());
                d.decode(td);
                v = d.toValue();

                if ((v == null) || v.notPresent()) {
                    return null;
                }

                return v;
            } else
            // generated because of "isPDU"
            if (typeName.equals("IkeSaInitRequest")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularIkeSaInitRequest d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularIkeSaInitRequest(dh.newInstance());
                d.decode(td);
                v = d.toValue();

                if ((v == null) || v.notPresent()) {
                    return null;
                }

                return v;
            } else
            // generated because of "isPDU"
            if (typeName.equals("IkeSaInitResponse")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularIkeSaInitResponse d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularIkeSaInitResponse(dh.newInstance());
                d.decode(td);
                v = d.toValue();

                if ((v == null) || v.notPresent()) {
                    return null;
                }

                return v;
            } else
            // generated because of "isPDU"
            if (typeName.equals("IkeAuthRequest")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularIkeAuthRequest d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularIkeAuthRequest(dh.newInstance());
                d.decode(td);
                v = d.toValue();

                if ((v == null) || v.notPresent()) {
                    return null;
                }

                return v;
            } else
            // generated because of "isPDU"
            if (typeName.equals("IkeAuthResponse")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularIkeAuthResponse d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularIkeAuthResponse(dh.newInstance());
                d.decode(td);
                v = d.toValue();

                if ((v == null) || v.notPresent()) {
                    return null;
                }

                return v;
            } else
            // generated because of "isPDU"
            if (typeName.equals("CreateChildSaRequest")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularCreateChildSaRequest d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularCreateChildSaRequest(dh.newInstance());
                d.decode(td);
                v = d.toValue();

                if ((v == null) || v.notPresent()) {
                    return null;
                }

                return v;
            } else
            // generated because of "isPDU"
            if (typeName.equals("CreateChildSaResponse")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularCreateChildSaResponse d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularCreateChildSaResponse(dh.newInstance());
                d.decode(td);
                v = d.toValue();

                if ((v == null) || v.notPresent()) {
                    return null;
                }

                return v;
            } else
            // generated because of "isPDU"
            if (typeName.equals("InformationalRequest")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularInformationalRequest d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularInformationalRequest(dh.newInstance());
                d.decode(td);
                v = d.toValue();

                if ((v == null) || v.notPresent()) {
                    return null;
                }

                return v;
            } else
            // generated because of "isPDU"
            if (typeName.equals("InformationalResponse")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularInformationalResponse d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularInformationalResponse(dh.newInstance());
                d.decode(td);
                v = d.toValue();

                if ((v == null) || v.notPresent()) {
                    return null;
                }

                return v;
            } else
            // generated because of "isPDU=LibIpv6_Interface_TypesAndValues"
            if (typeName.equals("Ipv6Payload")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularIpv6Payload d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularIpv6Payload(dh.newInstance());
                d.decode(td);
                v = d.toValue();

                if ((v == null) || v.notPresent()) {
                    return null;
                }

                return v;
            } else
            // generated because of "isPDU=used for external function only!"
            if (typeName.equals("MobileHeader")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularMobileHeader d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularMobileHeader(dh.newInstance());
                d.decode(td);
                v = d.toValue();

                if ((v == null) || v.notPresent()) {
                    return null;
                }

                return v;
            } else
            // generated because of "isPDU"
            if (typeName.equals("Ipv4Packet")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularIpv4Packet d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularIpv4Packet(dh.newInstance());
                d.decode(td);
                v = d.toValue();

                if ((v == null) || v.notPresent()) {
                    return null;
                }

                return v;
            } else
            // generated because of "isPDU"
            if (typeName.equals("Ipv4EchoRequest")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularIpv4EchoRequest d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularIpv4EchoRequest(dh.newInstance());
                d.decode(td);
                v = d.toValue();

                if ((v == null) || v.notPresent()) {
                    return null;
                }

                return v;
            } else
            // generated because of "isPDU"
            if (typeName.equals("Ipv4EchoReply")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularIpv4EchoReply d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularIpv4EchoReply(dh.newInstance());
                d.decode(td);
                v = d.toValue();

                if ((v == null) || v.notPresent()) {
                    return null;
                }

                return v;
            }
        } catch (TabularException tex) {
            logDecode(
                "TabularLibIpv6_Interface_TypesAndValues: Aborting decoding for " +
                dh + ". Problem was " + tex.getCause().getMessage());
            RB.getTciTLProvided().tliRT("", System.currentTimeMillis(), null,
                -1, null, RTLoggingConstants.RT_LOG_WARN,
                "TabularLibIpv6_Interface_TypesAndValues: Aborting decoding for " +
                dh + ". Problem was " + tex.getCause().getMessage());

            return v;
        }

        if (typeName.equals("octetstring")) {
            return super.decode(rm, dh);
        } else if (typeName.equals("bitstring")) {
            return super.decode(rm, dh);
        } else if (typeName.equals("hexstring")) {
            return super.decode(rm, dh);
        } else if (typeName.equals("charstring")) {
            return super.decode(rm, dh);
        } else if (typeName.equals("universal charstring")) {
            return super.decode(rm, dh);
        }

        return v;
    }

    public TriMessage encode(Value val) {
        BitArrayOutputStream baos = new BitArrayOutputStream();
        TabularEncoder enc = new TabularEncoder(baos, RB);

        String typeName = val.getType().getName();

        try {
            // generated because of "isPDU"
            if (typeName.equals("Ipv6Packet")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularIpv6Packet d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularIpv6Packet(val);
                d.encode(enc);

                return new TriMessageImpl(enc.toByteArray());
            } else
            // generated because of "isPDU"
            if (typeName.equals("DestinationUnreachable")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularDestinationUnreachable d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularDestinationUnreachable(val);
                d.encode(enc);

                return new TriMessageImpl(enc.toByteArray());
            } else
            // generated because of "isPDU"
            if (typeName.equals("PacketTooBig")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularPacketTooBig d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularPacketTooBig(val);
                d.encode(enc);

                return new TriMessageImpl(enc.toByteArray());
            } else
            // generated because of "isPDU"
            if (typeName.equals("TimeExceeded")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularTimeExceeded d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularTimeExceeded(val);
                d.encode(enc);

                return new TriMessageImpl(enc.toByteArray());
            } else
            // generated because of "isPDU"
            if (typeName.equals("ParameterProblem")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularParameterProblem d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularParameterProblem(val);
                d.encode(enc);

                return new TriMessageImpl(enc.toByteArray());
            } else
            // generated because of "isPDU"
            if (typeName.equals("EchoRequest")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularEchoRequest d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularEchoRequest(val);
                d.encode(enc);

                return new TriMessageImpl(enc.toByteArray());
            } else
            // generated because of "isPDU"
            if (typeName.equals("EchoReply")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularEchoReply d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularEchoReply(val);
                d.encode(enc);

                return new TriMessageImpl(enc.toByteArray());
            } else
            // generated because of "isPDU"
            if (typeName.equals("RouterAdvertisement")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularRouterAdvertisement d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularRouterAdvertisement(val);
                d.encode(enc);

                return new TriMessageImpl(enc.toByteArray());
            } else
            // generated because of "isPDU"
            if (typeName.equals("RouterSolicitation")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularRouterSolicitation d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularRouterSolicitation(val);
                d.encode(enc);

                return new TriMessageImpl(enc.toByteArray());
            } else
            // generated because of "isPDU"
            if (typeName.equals("NeighborSolicitation")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularNeighborSolicitation d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularNeighborSolicitation(val);
                d.encode(enc);

                return new TriMessageImpl(enc.toByteArray());
            } else
            // generated because of "isPDU"
            if (typeName.equals("NeighborAdvertisement")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularNeighborAdvertisement d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularNeighborAdvertisement(val);
                d.encode(enc);

                return new TriMessageImpl(enc.toByteArray());
            } else
            // generated because of "isPDU"
            if (typeName.equals("Redirect")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularRedirect d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularRedirect(val);
                d.encode(enc);

                return new TriMessageImpl(enc.toByteArray());
            } else
            // generated because of "isPDU"
            if (typeName.equals("RouterRenumbering")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularRouterRenumbering d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularRouterRenumbering(val);
                d.encode(enc);

                return new TriMessageImpl(enc.toByteArray());
            } else
            // generated because of "isPDU"
            if (typeName.equals("HomeAgentAddressDiscoveryRequest")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularHomeAgentAddressDiscoveryRequest d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularHomeAgentAddressDiscoveryRequest(val);
                d.encode(enc);

                return new TriMessageImpl(enc.toByteArray());
            } else
            // generated because of "isPDU"
            if (typeName.equals("HomeAgentAddressDiscoveryReply")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularHomeAgentAddressDiscoveryReply d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularHomeAgentAddressDiscoveryReply(val);
                d.encode(enc);

                return new TriMessageImpl(enc.toByteArray());
            } else
            // generated because of "isPDU"
            if (typeName.equals("MobilePrefixSolicitation")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularMobilePrefixSolicitation d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularMobilePrefixSolicitation(val);
                d.encode(enc);

                return new TriMessageImpl(enc.toByteArray());
            } else
            // generated because of "isPDU"
            if (typeName.equals("MobilePrefixAdvertisement")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularMobilePrefixAdvertisement d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularMobilePrefixAdvertisement(val);
                d.encode(enc);

                return new TriMessageImpl(enc.toByteArray());
            } else
            // generated because of "isPDU"
            if (typeName.equals("MipRouterAdvertisement")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularMipRouterAdvertisement d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularMipRouterAdvertisement(val);
                d.encode(enc);

                return new TriMessageImpl(enc.toByteArray());
            } else
            // generated because of "isPDU"
            if (typeName.equals("BindingRefreshRequest")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularBindingRefreshRequest d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularBindingRefreshRequest(val);
                d.encode(enc);

                return new TriMessageImpl(enc.toByteArray());
            } else
            // generated because of "isPDU"
            if (typeName.equals("HomeTestInit")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularHomeTestInit d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularHomeTestInit(val);
                d.encode(enc);

                return new TriMessageImpl(enc.toByteArray());
            } else
            // generated because of "isPDU"
            if (typeName.equals("CareOfTestInit")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularCareOfTestInit d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularCareOfTestInit(val);
                d.encode(enc);

                return new TriMessageImpl(enc.toByteArray());
            } else
            // generated because of "isPDU"
            if (typeName.equals("HomeTest")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularHomeTest d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularHomeTest(val);
                d.encode(enc);

                return new TriMessageImpl(enc.toByteArray());
            } else
            // generated because of "isPDU"
            if (typeName.equals("CareOfTest")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularCareOfTest d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularCareOfTest(val);
                d.encode(enc);

                return new TriMessageImpl(enc.toByteArray());
            } else
            // generated because of "isPDU"
            if (typeName.equals("BindingUpdate")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularBindingUpdate d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularBindingUpdate(val);
                d.encode(enc);

                return new TriMessageImpl(enc.toByteArray());
            } else
            // generated because of "isPDU"
            if (typeName.equals("BindingAcknowledgement")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularBindingAcknowledgement d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularBindingAcknowledgement(val);
                d.encode(enc);

                return new TriMessageImpl(enc.toByteArray());
            } else
            // generated because of "isPDU"
            if (typeName.equals("BindingError")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularBindingError d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularBindingError(val);
                d.encode(enc);

                return new TriMessageImpl(enc.toByteArray());
            } else
            // generated because of "isPDU"
            if (typeName.equals("FastBindingUpdate")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularFastBindingUpdate d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularFastBindingUpdate(val);
                d.encode(enc);

                return new TriMessageImpl(enc.toByteArray());
            } else
            // generated because of "isPDU"
            if (typeName.equals("FastBindingAcknowledgement")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularFastBindingAcknowledgement d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularFastBindingAcknowledgement(val);
                d.encode(enc);

                return new TriMessageImpl(enc.toByteArray());
            } else
            // generated because of "isPDU"
            if (typeName.equals("FastNeighborAdvertisement")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularFastNeighborAdvertisement d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularFastNeighborAdvertisement(val);
                d.encode(enc);

                return new TriMessageImpl(enc.toByteArray());
            } else
            // generated because of "isPDU"
            if (typeName.equals("RouterSolicitationForProxyRtAdv")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularRouterSolicitationForProxyRtAdv d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularRouterSolicitationForProxyRtAdv(val);
                d.encode(enc);

                return new TriMessageImpl(enc.toByteArray());
            } else
            // generated because of "isPDU"
            if (typeName.equals("ProxyRouterAdvertisement")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularProxyRouterAdvertisement d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularProxyRouterAdvertisement(val);
                d.encode(enc);

                return new TriMessageImpl(enc.toByteArray());
            } else
            // generated because of "isPDU"
            if (typeName.equals("HandoverInitiate")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularHandoverInitiate d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularHandoverInitiate(val);
                d.encode(enc);

                return new TriMessageImpl(enc.toByteArray());
            } else
            // generated because of "isPDU"
            if (typeName.equals("HandoverAcknowledge")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularHandoverAcknowledge d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularHandoverAcknowledge(val);
                d.encode(enc);

                return new TriMessageImpl(enc.toByteArray());
            } else
            // generated because of "isPDU"
            if (typeName.equals("OtherIcmpv6")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularOtherIcmpv6 d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularOtherIcmpv6(val);
                d.encode(enc);

                return new TriMessageImpl(enc.toByteArray());
            } else
            // generated because of "isPDU"
            if (typeName.equals("UdpPacket")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularUdpPacket d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularUdpPacket(val);
                d.encode(enc);

                return new TriMessageImpl(enc.toByteArray());
            } else
            // generated because of "isPDU"
            if (typeName.equals("IkeSaInitRequest")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularIkeSaInitRequest d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularIkeSaInitRequest(val);
                d.encode(enc);

                return new TriMessageImpl(enc.toByteArray());
            } else
            // generated because of "isPDU"
            if (typeName.equals("IkeSaInitResponse")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularIkeSaInitResponse d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularIkeSaInitResponse(val);
                d.encode(enc);

                return new TriMessageImpl(enc.toByteArray());
            } else
            // generated because of "isPDU"
            if (typeName.equals("IkeAuthRequest")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularIkeAuthRequest d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularIkeAuthRequest(val);
                d.encode(enc);

                return new TriMessageImpl(enc.toByteArray());
            } else
            // generated because of "isPDU"
            if (typeName.equals("IkeAuthResponse")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularIkeAuthResponse d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularIkeAuthResponse(val);
                d.encode(enc);

                return new TriMessageImpl(enc.toByteArray());
            } else
            // generated because of "isPDU"
            if (typeName.equals("CreateChildSaRequest")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularCreateChildSaRequest d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularCreateChildSaRequest(val);
                d.encode(enc);

                return new TriMessageImpl(enc.toByteArray());
            } else
            // generated because of "isPDU"
            if (typeName.equals("CreateChildSaResponse")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularCreateChildSaResponse d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularCreateChildSaResponse(val);
                d.encode(enc);

                return new TriMessageImpl(enc.toByteArray());
            } else
            // generated because of "isPDU"
            if (typeName.equals("InformationalRequest")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularInformationalRequest d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularInformationalRequest(val);
                d.encode(enc);

                return new TriMessageImpl(enc.toByteArray());
            } else
            // generated because of "isPDU"
            if (typeName.equals("InformationalResponse")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularInformationalResponse d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularInformationalResponse(val);
                d.encode(enc);

                return new TriMessageImpl(enc.toByteArray());
            } else
            // generated because of "isPDU=LibIpv6_Interface_TypesAndValues"
            if (typeName.equals("Ipv6Payload")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularIpv6Payload d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularIpv6Payload(val);
                d.encode(enc);

                return new TriMessageImpl(enc.toByteArray());
            } else
            // generated because of "isPDU=used for external function only!"
            if (typeName.equals("MobileHeader")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularMobileHeader d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularMobileHeader(val);
                d.encode(enc);

                return new TriMessageImpl(enc.toByteArray());
            } else
            // generated because of "isPDU"
            if (typeName.equals("Ipv4Packet")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularIpv4Packet d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularIpv4Packet(val);
                d.encode(enc);

                return new TriMessageImpl(enc.toByteArray());
            } else
            // generated because of "isPDU"
            if (typeName.equals("Ipv4EchoRequest")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularIpv4EchoRequest d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularIpv4EchoRequest(val);
                d.encode(enc);

                return new TriMessageImpl(enc.toByteArray());
            } else
            // generated because of "isPDU"
            if (typeName.equals("Ipv4EchoReply")) {
                com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularIpv4EchoReply d =
                    new com.testingtech.generated.codec.LibIpv6_Interface_TypesAndValues.TabularIpv4EchoReply(val);
                d.encode(enc);

                return new TriMessageImpl(enc.toByteArray());
            }
        } catch (TabularException tex) {
            logDecode(
                "TabularLibIpv6_Interface_TypesAndValues:: An error encountered while encoding. Reason: " +
                tex.getCause().getMessage());
            RB.getTciTLProvided().tliRT("", System.currentTimeMillis(), null,
                -1, null, RTLoggingConstants.RT_LOG_WARN,
                "TabularLibIpv6_Interface_TypesAndValues:: An error encountered while encoding. Reason: " +
                tex.getCause().getMessage());

            return null;
        }

        if (typeName.equals("octetstring")) {
            return super.encode(val);
        } else if (typeName.equals("bitstring")) {
            return super.encode(val);
        } else if (typeName.equals("charstring")) {
            return super.encode(val);
        } else if (typeName.equals("universal charstring")) {
            return super.encode(val);
        } else if (typeName.equals("hexstring")) {
            return super.encode(val);
        }

        return null;
    }
}
